#Solution to PythonSequences Lab


# this function compresses a text file by first listing unique words
#       and then by listing indices in the array of unique words
# run it by calling Compress("animalsSmall.txt") or Compress("animals.txt")
#       and examine the output files created (e.g. animalsSmall_compressed.txt)
def Compress(fileName):

    #read file into list of words
    file = open(fileName, "r")
    words = file.readlines()
    file.close()

    #find unique words
    uniqueWords = [] #initially array of unique words is empty
    for word in words:
        found = False
        # see if current word is already part of array of unique words
        for uword in uniqueWords: 
            if uword == word:
                found = True
                break
        if found == False:
            uniqueWords.append(word) # current word hasn't yet been encounterd

    #compute sequence of indices
    indexSequence = []
    for word in words:
        # find current word in array of unique words
        for i in range(0, len(uniqueWords)): 
            if uniqueWords[i] == word:
                indexSequence.append(i) # add its index to array of indices
                break

    #write compressed file
    cfileName = fileName[:-4] + '_compressed.txt'
    cfile = open(cfileName, "w")
    print(len(uniqueWords), file=cfile) # first write number of unique words
    for uword in uniqueWords: # write unique words
        print(uword[0:-1], file=cfile)
   
    for i in indexSequence: # write indices
        print(i, file=cfile)
    cfile.close()
    
